/* Agent Tcl
   Bob Gray
   10 January 1996

   genConversion.h

   This file defines various conversion routines.

   Copyright (c) 1995-1996, Bob Gray, Dartmouth College

   See the file "agent.terms" for information on usage and redistribution
   of this file and for a DISCLAIMER OF ALL WARRANTIES.
*/

#ifndef _GEN_CONVERSION_H
#define _GEN_CONVERSION_H

#ifndef NO_PRAGMAS
#pragma interface
#endif

#ifndef _PLAT_SIZES_H
#include "platSizes.h"
#endif

    /* forward declarations so we can compile */

class AgentId;
class BASE_SECURITY;
class MachineId;

    /* conversion routines */

char *Agent_IdToString
	(const struct AgentId *id);

char *Agent_MachineToString
	(const struct MachineId *id);

char *Agent_SecurityToString
	(const struct BASE_SECURITY *id);

char *Agent_MeetingStatusToString
	(const UINT_8 status);

char *Agent_IpToString
	(const UINT_32 ip);

int Agent_StringToIp
	(char *string, UINT_32 *ip);

#endif
