/* Agent Tcl
   Bob Gray
   28 Spetember 1995

   platSystem.h

   This file defines a class that allows a process to perform certain
   system-level operations.

   Copyright (c) 1995-1997, Robert S. Gray Dartmouth College

   See the file "agent.terms" for information on usage and redistribution
   of this file and for a DISCLAIMER OF ALL WARRANTIES.
*/

#ifndef _PLAT_SYSTEM_H
#define _PLAT_SYSTEM_H

#ifndef NO_PRAGMAS
#pragma interface
#endif

     /* forward declarations */
    
struct timeval;
 
class SystemUtil
{
    public:
	
	    /* 
	     * convert a system errno into a string
	     */

	static const char *errnoToShortString (int errorNo);
	static const char *errnoToLongString (int errorNo);

	    /* 
             * get the current wall and cpu time 
             */

	static struct timeval getCurrentWall (void);
	static struct timeval getCurrentCpu (void);

	    /* 
             * set the starting cpu time
             */

        static void setStartingCpu (struct timeval start);

	    /* 
	     * initialize a raw file descriptor (e.g., in Java, create an 
	     * entry in the monitor table)                          
	     */

	static void initializeRawFd (int fd);
};

#endif
